package stackjava.com.hibernateversion;

import stackjava.com.hibernateversion.dao.CustomerDAO;
import stackjava.com.hibernateversion.entities.Customer;

public class MainApp {
	public static void main(String[] args) {
		demoInsert();
//		demoUpdate();
//		demoSearchByName();
//		demoDelete();
//		demoLocking();
		
	}
	
	public static void demoLocking() {
		CustomerDAO customerDAO = new CustomerDAO();
		Customer customer1 = customerDAO.findById(1);
		Customer customer2 = customerDAO.findById(1);
		
		customer1.setAddress("Nam Dinh");
		customerDAO.update(customer1);
		
		customer2.setAddress("Vinh Phuc");
//		customer2.setVersion(customer1.getVersion());
		customerDAO.update(customer2);
	}
	
	public static void demoUpdate() {
		CustomerDAO customerDAO = new CustomerDAO();
		Customer customer = customerDAO.findById(2);
		customer.setAddress("Titan");
		customerDAO.update(customer);
	}
	
	public static void demoInsert() {
		CustomerDAO customerDAO = new CustomerDAO();
		customerDAO.save(new Customer("Kai", "Viet Nam"));
		customerDAO.save(new Customer("Thanos", "Viet Nam"));
		customerDAO.save(new Customer("Thor", "Asgard"));
		customerDAO.save(new Customer("Hulk", "USA"));
		customerDAO.save(new Customer("Iron Man", "USA"));
	}
	
	public static void demoFindById() {
		CustomerDAO customerDAO = new CustomerDAO();
		customerDAO.findById(2);
	}
	
	public static void demoShowAll() {
		CustomerDAO customerDAO = new CustomerDAO();
		customerDAO.showAll();
	}
	
	public static void demoDelete() {
		CustomerDAO customerDAO = new CustomerDAO();
		Customer customer = customerDAO.findById(5);
		customerDAO.delete(customer);
	}
}
